#!/system/bin/sh

baudr="9600"
#module="pl2303"
module="cp210x"
delay="30"
modpath="/data/lib/modules"
binprefix="/system/bin/busybox "
device=`getprop ro.android.gps.provider`
[ -z "${device}" ] && setprop ro.android.gps.provider ttyUSB0

case ${1} in
start)
	echo "Kernelmodul ${module} wird geladen."
	${binprefix}insmod ${modpath}/${module}.ko >/dev/null 2>&1
	i=$delay
	while [ ${i} -gt 0 ]; do
		[ -c /dev/${device} ] && break
		${binprefix}printf "\rUSB-GPS Device in den naechsten %02d Sekunden anstecken ..." ${i}
		i=$((i-1))
		${binprefix}sleep 1
	done
	if [ -c /dev/${device} ]; then
		echo "Device: ${device} wird auf ${baudr} Baud eingestellt."
		${binprefix}stty -F /dev/${device} ispeed ${baudr} >/dev/null 2>&1
	fi
	;;

stop)
	echo "Kernelmodul $[device} wird entladen."
	${binprefix}rmmod ${module} >/dev/null 2>&1
	;;

test)
	echo "GPS an ${device} wird getestet ..."
	${binprefix}cat </dev/ttyUSB0 & >/dev/null 2>&1
	${binprefix}sleep 5
	${binprefix}killall cat >/dev/null 2>&1
	echo "Wenn keine Signale zu sehen waren, das Skript noch einmal laufen lassen."
	;;

restart)
	$0 stop
	$0 start
	;;

*)
	echo "Aufruf: $0 start|stop|restart|test"

esac

exit 0

